/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-24 18:11
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 104;
/* const ll INF = 1LL << 60; */

ll N;

ll parent[MAXN];
ll color[MAXN];
vector<int> childs[MAXN];


int dfs(int u, int de = 0){
    int res = de;
    for(int v : childs[u]){
        color[v] = de % 3;
        res = max(res, dfs(v, de + 1));
    }
    return res;
}

void solve(){
    // Code goes here ...
    cin >> N;
    int p;
    F(i, 2, N + 1){
        cin >> p;
        parent[i] = p;
        childs[p].push_back(i);
        /* cout << p << " gets " << i << endl; */
    }

    int md = dfs(1);
    int numc = min(md, 3);
    cout << numc << endl;
    F(i, 2, N+1)
        cout << color[i] + 1 << " ";
    cout << endl;

    int status;
    int es[numc];
    while(1){
        cin >> status;
        if(status == 0){
            // play
            R(i, numc) cin >> es[i];
            int c = 0;
            while(1){
                if(es[c] == 0){
                    cout << ((c - 1 + numc) % numc) + 1 << endl;
                    break;
                }
                c++;
            }
        }
        else break;
    }
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
